///////////////////////////////////////
//  copyright Alexandre Chouvellon 2009
//  Source libre de droit
///////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include "structure.h"
#include "donkey.h"
#include "tools.h"
#include "list.fwd.h"
#include "analysis.h"
#include "language.fwd.h"
#include "timer.h"

//liste des configurations dj tudies
extern MyFifoList  *  glb_myFifo;


FILE *  scanArgs(char ** argv)
{
	int i=1;
	FILE * file  = NULL;

	if( argv[i][1] == 'v')
	{
		printf(glb_copyright);
		return file;
	}

	if( argv[i][1] == 'h')
	{
		printf(glb_usage, argv[0]);
		return file;
	}

	if( argv[i][1] == 'f')
	{
		fopen_s(&file,argv[i+1], "r");
		if(!file)
		{
			printf(glb_fileNotFound,argv[i+1]);
		}
		return file;
	}

	printf(glb_unknownOption);

	return file;
}

int initProcess(Board * board)
{    
	startTimer();
	return updateAfterMove( board, -1, getLocationToken(BLANK1), getLocationToken(BLANK2), NULL);
}

void freeMemory()
{
	freeFifo(glb_myFifo);
	freeAllChainedLists();
}


int main (int argc, char ** argv)
{
	FILE * file;

	if(argc == 1 || argc > 4) {printf(glb_usage, argv[0]);}

	file = scanArgs(argv);

	if (file)
	{
		Board board = {0};


		//chargement des donnes
		if (!loadFile(file, &board))
		{
			printf(glb_fileFailedToLoad);
			return 1;
		}

		//vrification de l'tat du plateau
		if (!checkConsistancy(&board))
		{
			printf(glb_unconsistantBoard);
			return 1;
		}

		//lancement du process de recherche
		if (!(initProcess(&board) || analyseStateFIFO(0)))
		{
			printf(glb_nothingFound, stopTimer());
		}

		//on libre la mmoire parce qu'on est bien lev
		freeMemory();
	}
	return 0;
}
