///////////////////////////////////////
//  copyright Alexandre Chouvellon 2009
//  Source libre de droit
///////////////////////////////////////

#include <stdio.h>
#include "donkey.h"
#include "move.h"
#include "structure.h"
#include "language.fwd.h"
#include "errorId.h"

//fichier de dplacement des pices au cas par cas

int moveDoubleHorizontal(short int id, short int orientation, Board * board, char row, char col, Location * blank1, Location * blank2)
{
	short int spot =1;
	switch(orientation)
	{
	case TOP : 
		{
			if(row ==0) return FALSE; 

			switch(row)
			{
			case 1:
				{ 

					switch(col)
					{
					case 0: spot = (board->row0 & MASK0) | (board->row0 & MASK1); //la place est elle libre?
						if(!spot) 
						{
							board->row0 += (id <<OFFSET0) + (id << OFFSET1);
							board->row1&=~ ( id << OFFSET0); board->row1&=~ ( id << OFFSET1);
						} 
						break;
					case 1: spot = (board->row0 & MASK1) | (board->row0 & MASK2); if(!spot) {board->row0 += (id <<OFFSET1) + (id << OFFSET2);board->row1&=~ ( id << OFFSET1); board->row1&=~ ( id << OFFSET2);}break;
					case 2: spot = (board->row0 & MASK2) | (board->row0 & MASK3); if(!spot) {board->row0 += (id <<OFFSET2) + (id << OFFSET3);board->row1&=~ ( id << OFFSET2); board->row1&=~ ( id << OFFSET3);}break;
					}

				}break;
			case 2: 
				{ 
					switch(col)
					{
					case 0: spot = (board->row1 & MASK0) | (board->row1 & MASK1);if(!spot) {board->row1 += (id <<OFFSET0) + (id << OFFSET1);board->row2&=~ ( id << OFFSET0); board->row2&=~ ( id << OFFSET1);}break;
					case 1: spot = (board->row1 & MASK1) | (board->row1 & MASK2);if(!spot) {board->row1 += (id <<OFFSET1) + (id << OFFSET2);board->row2&=~ ( id << OFFSET1); board->row2&=~ ( id << OFFSET2);}break;
					case 2: spot = (board->row1 & MASK2) | (board->row1 & MASK3);if(!spot) {board->row1 += (id <<OFFSET2) + (id << OFFSET3);board->row2&=~ ( id << OFFSET2); board->row2&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 3:
				{ 

					switch(col)
					{
					case 0: spot = (board->row2 & MASK0) | (board->row2 & MASK1);if(!spot) {board->row2 += (id <<OFFSET0) + (id << OFFSET1);board->row3&=~ ( id << OFFSET0); board->row3&=~ ( id << OFFSET1);}break;
					case 1: spot = (board->row2 & MASK1) | (board->row2 & MASK2);if(!spot) {board->row2 += (id <<OFFSET1) + (id << OFFSET2);board->row3&=~ ( id << OFFSET1); board->row3&=~ ( id << OFFSET2);}break;
					case 2: spot = (board->row2 & MASK2) | (board->row2 & MASK3);if(!spot) {board->row2 += (id <<OFFSET2) + (id << OFFSET3);board->row3&=~ ( id << OFFSET2); board->row3&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 4:
				{ 

					switch(col)
					{
					case 0: spot = (board->row3 & MASK0) | (board->row3 & MASK1);if(!spot) {board->row3 += (id <<OFFSET0) + (id << OFFSET1);board->row4&=~ ( id << OFFSET0); board->row4&=~ ( id << OFFSET1);}break;
					case 1: spot = (board->row3 & MASK1) | (board->row3 & MASK2);if(!spot) {board->row3 += (id <<OFFSET1) + (id << OFFSET2);board->row4&=~ ( id << OFFSET1); board->row4&=~ ( id << OFFSET2);}break;
					case 2: spot = (board->row3 & MASK2) | (board->row3 & MASK3);if(!spot) {board->row3 += (id <<OFFSET2) + (id << OFFSET3);board->row4&=~ ( id << OFFSET2); board->row4&=~ ( id << OFFSET3);}break;
					}
				}break;
			default : printf(glb_errorMessage, ERROR_MOVE1);
			}

			if(!spot)
			{
				setLocation(blank2,row,col+1);setLocation(blank1,row,col);
			}
			break;
		}
	case BOTTOM : 
		{
			if(row == MAX_ROW-1) return FALSE;

			switch(row)
			{
			case 0:
				{ 

					switch(col)
					{
					case 0: spot = (board->row1 & MASK0) | (board->row1 & MASK1);if(!spot) {board->row1 += (id <<OFFSET0) + (id << OFFSET1);board->row0&=~ ( id << OFFSET0); board->row0&=~ ( id << OFFSET1);}break;
					case 1: spot = (board->row1 & MASK1) | (board->row1 & MASK2);if(!spot) {board->row1 += (id <<OFFSET1) + (id << OFFSET2);board->row0&=~ ( id << OFFSET1); board->row0&=~ ( id << OFFSET2);}break;
					case 2: spot = (board->row1 & MASK2) | (board->row1 & MASK3);if(!spot) {board->row1 += (id <<OFFSET2) + (id << OFFSET3);board->row0&=~ ( id << OFFSET2); board->row0&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 1:
				{ 

					switch(col)
					{
					case 0: spot = (board->row2 & MASK0) | (board->row2 & MASK1);if(!spot) {board->row2 += (id <<OFFSET0) + (id << OFFSET1);board->row1&=~ ( id << OFFSET0); board->row1&=~ ( id << OFFSET1);}break;
					case 1: spot = (board->row2 & MASK1) | (board->row2 & MASK2);if(!spot) {board->row2 += (id <<OFFSET1) + (id << OFFSET2);board->row1&=~ ( id << OFFSET1); board->row1&=~ ( id << OFFSET2);}break;
					case 2: spot = (board->row2 & MASK2) | (board->row2 & MASK3);if(!spot) {board->row2 += (id <<OFFSET2) + (id << OFFSET3);board->row1&=~ ( id << OFFSET2); board->row1&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 2: 
				{ 

					switch(col)
					{
					case 0: spot = (board->row3 & MASK0) | (board->row3 & MASK1);if(!spot) {board->row3 += (id <<OFFSET0) + (id << OFFSET1);board->row2&=~ ( id << OFFSET0); board->row2&=~ ( id << OFFSET1);}break;
					case 1: spot = (board->row3 & MASK1) | (board->row3 & MASK2);if(!spot) {board->row3 += (id <<OFFSET1) + (id << OFFSET2);board->row2&=~ ( id << OFFSET1); board->row2&=~ ( id << OFFSET2);}break;
					case 2: spot = (board->row3 & MASK2) | (board->row3 & MASK3);if(!spot) {board->row3 += (id <<OFFSET2) + (id << OFFSET3);board->row2&=~ ( id << OFFSET2); board->row2&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 3:
				{ 

					switch(col)
					{
					case 0: spot = (board->row4 & MASK0) | (board->row4 & MASK1);if(!spot) {board->row4 += (id <<OFFSET0) + (id << OFFSET1);board->row3&=~ ( id << OFFSET0); board->row3&=~ ( id << OFFSET1);}break;
					case 1: spot = (board->row4 & MASK1) | (board->row4 & MASK2);if(!spot) {board->row4 += (id <<OFFSET1) + (id << OFFSET2);board->row3&=~ ( id << OFFSET1); board->row3&=~ ( id << OFFSET2);}break;
					case 2: spot = (board->row4 & MASK2) | (board->row4 & MASK3);if(!spot) {board->row4 += (id <<OFFSET2) + (id << OFFSET3);board->row3&=~ ( id << OFFSET2); board->row3&=~ ( id << OFFSET3);}break;
					}
					break;
				}break;
			default : printf(glb_errorMessage,ERROR_MOVE2);
			}

			//on MAJ la position de la piece
			if(!spot)
			{
				setLocation(blank2,row,col+1);setLocation(blank1,row,col);
			}
		}break;
	case LEFT : 
		{
			if(col == 0) return FALSE;


			switch(row)
			{
			case 0:
				{ 

					switch(col)
					{
					case 1: spot = (board->row0 & MASK0);if(!spot) {board->row0 += (id <<OFFSET0); board->row0&=~ ( id << OFFSET2);}break;
					case 2: spot = (board->row0 & MASK1);if(!spot) {board->row0 += (id <<OFFSET1); board->row0&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 1:
				{ 

					switch(col)
					{
					case 1: spot = (board->row1 & MASK0) ;if(!spot) {board->row1 += (id <<OFFSET0); board->row1&=~ ( id << OFFSET2);}break;
					case 2: spot = (board->row1 & MASK1) ;if(!spot) {board->row1 += (id <<OFFSET1); board->row1&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 2: 
				{ 

					switch(col)
					{
					case 1: spot = (board->row2 & MASK0) ;if(!spot) {board->row2 += (id <<OFFSET0); board->row2&=~ ( id << OFFSET2);}break;
					case 2: spot = (board->row2 & MASK1) ;if(!spot) {board->row2 += (id <<OFFSET1); board->row2&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 3:
				{ 

					switch(col)
					{
					case 1: spot = (board->row3 & MASK0) ;if(!spot) {board->row3 += (id <<OFFSET0); board->row3&=~ ( id << OFFSET2);}break;
					case 2: spot = (board->row3 & MASK1) ;if(!spot) {board->row3 += (id <<OFFSET1); board->row3&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 4:
				{ 

					switch(col)
					{
					case 1: spot = (board->row4 & MASK0) ;if(!spot) {board->row4 += (id <<OFFSET0); board->row4&=~ ( id << OFFSET2);}break;
					case 2: spot = (board->row4 & MASK1) ;if(!spot) {board->row4 += (id <<OFFSET1); board->row4&=~ ( id << OFFSET3);}break;
					}
				}break;
			default : printf(glb_errorMessage,ERROR_MOVE3);
			}

			if(!spot)
			{
				if((col-1) == (blank2->column ) && ((row) == blank2->row))
					setLocation(blank2,row,col +1);
				else
					setLocation(blank1,row,col+1);
			}
		}break;
	case RIGHT : 
		{
			if(col == MAX_COL-2) return FALSE;


			switch(row)
			{
			case 0:
				{ 

					switch(col)
					{
					case 0: spot =  (board->row0 & MASK2);if(!spot) {board->row0 += (id <<OFFSET2); board->row0&=~ ( id << OFFSET0);}break;
					case 1: spot =  (board->row0 & MASK3);if(!spot) {board->row0 += (id <<OFFSET3); board->row0&=~ ( id << OFFSET1);}break;
					}
				}break;
			case 1:
				{ 

					switch(col)
					{
					case 0: spot = (board->row1 & MASK2);if(!spot) {board->row1 += (id <<OFFSET2); board->row1&=~ ( id << OFFSET0);}break;
					case 1: spot = (board->row1 & MASK3);if(!spot) {board->row1 += (id <<OFFSET3); board->row1&=~ ( id << OFFSET1);}break;
					}
				}break;
			case 2: 
				{ 

					switch(col)
					{
					case 0: spot = (board->row2 & MASK2);if(!spot) {board->row2 += (id <<OFFSET2); board->row2&=~ ( id << OFFSET0);}break;
					case 1: spot = (board->row2 & MASK3);if(!spot) {board->row2 += (id <<OFFSET3); board->row2&=~ ( id << OFFSET1);}break;
					}
				}break;
			case 3:
				{ 

					switch(col)
					{
					case 0: spot = (board->row3 & MASK2);if(!spot) {board->row3 += (id <<OFFSET2); board->row3&=~ ( id << OFFSET0);}break;
					case 1: spot = (board->row3 & MASK3);if(!spot) {board->row3 += (id <<OFFSET3); board->row3&=~ ( id << OFFSET1);}break;
					}
				}break;
			case 4:
				{ 

					switch(col)
					{
					case 0: spot = (board->row4 & MASK2);if(!spot) {board->row4 += (id <<OFFSET2); board->row4&=~ ( id << OFFSET0);}break;
					case 1: spot = (board->row4 & MASK3);if(!spot) {board->row4 += (id <<OFFSET3); board->row4&=~ ( id << OFFSET1);}break;
					}
				}break;
			default : printf(glb_errorMessage,ERROR_MOVE4);
			}
		}
		if(!spot)
		{
			if((col+2) == (blank2->column ) && ((row) == blank2->row))
				setLocation(blank2,row,col );
			else
				setLocation(blank1,row,col);
		}

		break;
	}

	return !spot;
}

int moveDoubleVertical(short int id, short int orientation, Board * board, char row, char col, Location * blank1, Location * blank2)
{
	int spot = 0;

	// on tudie les cas limites
	switch(orientation)
	{
	case TOP : 
		{
			if(row ==0 ||  row == 4) return FALSE; 
			switch(row)
			{
			case 1:
				{ 

					switch(col)
					{
					case 0: spot = board->row0 & MASK0;if(!spot) {board->row0 += (id <<OFFSET0); board->row2&=~ ( id << OFFSET0);}break;
					case 1: spot = board->row0 & MASK1;if(!spot) {board->row0 += (id <<OFFSET1); board->row2&=~ ( id << OFFSET1);}break;
					case 2: spot = board->row0 & MASK2;if(!spot) {board->row0 += (id <<OFFSET2); board->row2&=~ ( id << OFFSET2);}break;
					case 3: spot = board->row0 & MASK3;if(!spot) {board->row0 += (id <<OFFSET3); board->row2&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 2: 
				{ 

					switch(col)
					{
					case 0: spot = board->row1 & MASK0;if(!spot) {board->row1 += (id <<OFFSET0); board->row3&=~ ( id << OFFSET0);}break;
					case 1: spot = board->row1 & MASK1;if(!spot) {board->row1 += (id <<OFFSET1); board->row3&=~ ( id << OFFSET1);}break;
					case 2: spot = board->row1 & MASK2;if(!spot) {board->row1 += (id <<OFFSET2); board->row3&=~ ( id << OFFSET2);}break;
					case 3: spot = board->row1 & MASK3;if(!spot) {board->row1 += (id <<OFFSET3); board->row3&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 3:
				{ 

					switch(col)
					{
					case 0: spot = board->row2 & MASK0;if(!spot) {board->row2 += (id <<OFFSET0); board->row4&=~ ( id << OFFSET0);}break;
					case 1: spot = board->row2 & MASK1;if(!spot) {board->row2 += (id <<OFFSET1); board->row4&=~ ( id << OFFSET1);}break;
					case 2: spot = board->row2 & MASK2;if(!spot) {board->row2 += (id <<OFFSET2); board->row4&=~ ( id << OFFSET2);}break;
					case 3: spot = board->row2 & MASK3;if(!spot) {board->row2 += (id <<OFFSET3); board->row4&=~ ( id << OFFSET3);}break;
					}
				}break;
			default : printf(glb_errorMessage,ERROR_MOVE5);
			}
			if(!spot)
			{
				if(col == blank2->column && ((row-1) == blank2->row))
					setLocation(blank2,row+1,col);
				else
					setLocation(blank1,row+1,col);
			}
		}break;
	case BOTTOM : {
		if(row == 3 ) return FALSE;

		switch(row)
		{
		case 0:
			{ 

				switch(col)
				{
				case 0: spot = board->row2 & MASK0;if(!spot) {board->row2 += (id <<OFFSET0); board->row0&=~ ( id << OFFSET0);}break;
				case 1: spot = board->row2 & MASK1;if(!spot) {board->row2 += (id <<OFFSET1); board->row0&=~ ( id << OFFSET1);}break;
				case 2: spot = board->row2 & MASK2;if(!spot) {board->row2 += (id <<OFFSET2); board->row0&=~ ( id << OFFSET2);}break;
				case 3: spot = board->row2 & MASK3;if(!spot) {board->row2 += (id <<OFFSET3); board->row0&=~ ( id << OFFSET3);}break;
				}
			}break;
		case 1:
			{ 

				switch(col)
				{
				case 0: spot = board->row3 & MASK0;if(!spot) {board->row3 += (id <<OFFSET0); board->row1&=~ ( id << OFFSET0);}break;
				case 1: spot = board->row3 & MASK1;if(!spot) {board->row3 += (id <<OFFSET1); board->row1&=~ ( id << OFFSET1);}break;
				case 2: spot = board->row3 & MASK2;if(!spot) {board->row3 += (id <<OFFSET2); board->row1&=~ ( id << OFFSET2);}break;
				case 3: spot = board->row3 & MASK3;if(!spot) {board->row3 += (id <<OFFSET3); board->row1&=~ ( id << OFFSET3);}break;
				}
			}break;
		case 2: 
			{ 

				switch(col)
				{
				case 0: spot = board->row4 & MASK0;if(!spot) {board->row4 += (id <<OFFSET0); board->row2&=~ ( id << OFFSET0);}break;
				case 1: spot = board->row4 & MASK1;if(!spot) {board->row4 += (id <<OFFSET1); board->row2&=~ ( id << OFFSET1);}break;
				case 2: spot = board->row4 & MASK2;if(!spot) {board->row4 += (id <<OFFSET2); board->row2&=~ ( id << OFFSET2);}break;
				case 3: spot = board->row4 & MASK3;if(!spot) {board->row4 += (id <<OFFSET3); board->row2&=~ ( id << OFFSET3);}break;
				}
			}break;
		default : printf(glb_errorMessage,ERROR_MOVE6);
		}
		if(!spot)
		{
			if(col == blank2->column && ((row+2) == blank2->row))
				setLocation(blank2,row,col);
			else
				setLocation(blank1,row,col);
		}
				  }break;
	case LEFT : 
		{
			if(col == 0) return FALSE;


			switch(row)
			{
			case 0:
				{ 

					switch(col)
					{
					case 1: spot = (board->row0 & MASK0) | (board->row1 & MASK0);if(!spot) {board->row0 += (id <<OFFSET0); board->row1 += (id<<OFFSET0); board->row0&=~ ( id << OFFSET1);board->row1&=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row0 & MASK1) | (board->row1 & MASK1);if(!spot) {board->row0 += (id <<OFFSET1); board->row1 += (id<<OFFSET1); board->row0&=~ ( id << OFFSET2);board->row1&=~ ( id << OFFSET2);}break;
					case 3: spot = (board->row0 & MASK2) | (board->row1 & MASK2);if(!spot) {board->row0 += (id <<OFFSET2); board->row1 += (id<<OFFSET2); board->row0&=~ ( id << OFFSET3);board->row1&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 1:
				{ 

					switch(col)
					{
					case 1: spot = (board->row1 & MASK0) | (board->row2 & MASK0);if(!spot) {board->row1 += (id <<OFFSET0); board->row2 += (id<<OFFSET0); board->row1&=~ ( id << OFFSET1);board->row2&=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row1 & MASK1) | (board->row2 & MASK1);if(!spot) {board->row1 += (id <<OFFSET1); board->row2 += (id<<OFFSET1); board->row1&=~ ( id << OFFSET2);board->row2&=~ ( id << OFFSET2);}break;
					case 3: spot = (board->row1 & MASK2) | (board->row2 & MASK2);if(!spot) {board->row1 += (id <<OFFSET2); board->row2 += (id<<OFFSET2); board->row1&=~ ( id << OFFSET3);board->row2&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 2: 
				{ 

					switch(col)
					{
					case 1: spot = (board->row2 & MASK0) | (board->row3 & MASK0);if(!spot) {board->row2 += (id <<OFFSET0); board->row3 += (id<<OFFSET0); board->row2&=~ ( id << OFFSET1);board->row3&=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row2 & MASK1) | (board->row3 & MASK1);if(!spot) {board->row2 += (id <<OFFSET1); board->row3 += (id<<OFFSET1); board->row2&=~ ( id << OFFSET2);board->row3&=~ ( id << OFFSET2);}break;
					case 3: spot = (board->row2 & MASK2) | (board->row3 & MASK2);if(!spot) {board->row2 += (id <<OFFSET2); board->row3 += (id<<OFFSET2); board->row2&=~ ( id << OFFSET3);board->row3&=~ ( id << OFFSET3);}break;
					}
				}break;
			case 3:
				{ 

					switch(col)
					{
					case 1: spot = (board->row3 & MASK0) | (board->row4 & MASK0);if(!spot) {board->row3 += (id <<OFFSET0); board->row4 += (id<<OFFSET0); board->row3&=~ ( id << OFFSET1);board->row4&=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row3 & MASK1) | (board->row4 & MASK1);if(!spot) {board->row3 += (id <<OFFSET1); board->row4 += (id<<OFFSET1); board->row3&=~ ( id << OFFSET2);board->row4&=~ ( id << OFFSET2);}break;
					case 3: spot = (board->row3 & MASK2) | (board->row4 & MASK2);if(!spot) {board->row3 += (id <<OFFSET2); board->row4 += (id<<OFFSET2); board->row3&=~ ( id << OFFSET3);board->row4&=~ ( id << OFFSET3);}break;
					}
				}break;
			default : printf(glb_errorMessage,ERROR_MOVE7);
			}
			if(!spot)
			{
				setLocation(blank1,row,col); setLocation(blank2,row+1, col);
			}
		}break;
	case RIGHT : 
		{
			if(col == MAX_COL-1) return FALSE;


			switch(row)
			{
			case 0:
				{ 
					switch(col)
					{
					case 0: spot = (board->row0 & MASK1) | (board->row1 & MASK1);if(!spot) {board->row0 += (id <<OFFSET1); board->row1 += (id<<OFFSET1); board->row0&=~ ( id << OFFSET0);board->row1&=~ ( id << OFFSET0);}break;
					case 1: spot = (board->row0 & MASK2) | (board->row1 & MASK2);if(!spot) {board->row0 += (id <<OFFSET2); board->row1 += (id<<OFFSET2); board->row0&=~ ( id << OFFSET1);board->row1&=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row0 & MASK3) | (board->row1 & MASK3);if(!spot) {board->row0 += (id <<OFFSET3); board->row1 += (id<<OFFSET3); board->row0&=~ ( id << OFFSET2);board->row1&=~ ( id << OFFSET2);}break;
					}
				}break;
			case 1:
				{ 

					switch(col)
					{
					case 0: spot = (board->row1 & MASK1) | (board->row2 & MASK1);if(!spot) {board->row1 += (id <<OFFSET1); board->row2 += (id<<OFFSET1); board->row1&=~ ( id << OFFSET0);board->row2&=~ ( id << OFFSET0);}break;
					case 1: spot = (board->row1 & MASK2) | (board->row2 & MASK2);if(!spot) {board->row1 += (id <<OFFSET2); board->row2 += (id<<OFFSET2); board->row1&=~ ( id << OFFSET1);board->row2&=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row1 & MASK3) | (board->row2 & MASK3);if(!spot) {board->row1 += (id <<OFFSET3); board->row2 += (id<<OFFSET3); board->row1&=~ ( id << OFFSET2);board->row2&=~ ( id << OFFSET2);}break;
					}
				}break;
			case 2: 
				{ 

					switch(col)
					{
					case 0: spot = (board->row2 & MASK1) | (board->row3 & MASK1);if(!spot) {board->row2 += (id <<OFFSET1); board->row3 += (id<<OFFSET1); board->row2&=~ ( id << OFFSET0);board->row3&=~ ( id << OFFSET0);}break;
					case 1: spot = (board->row2 & MASK2) | (board->row3 & MASK2);if(!spot) {board->row2 += (id <<OFFSET2); board->row3 += (id<<OFFSET2); board->row2&=~ ( id << OFFSET1);board->row3&=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row2 & MASK3) | (board->row3 & MASK3);if(!spot) {board->row2 += (id <<OFFSET3); board->row3 += (id<<OFFSET3); board->row2&=~ ( id << OFFSET2);board->row3&=~ ( id << OFFSET2);}break;
					}
				}break;
			case 3:
				{ 

					switch(col)
					{
					case 0: spot = (board->row3 & MASK1) | (board->row4 & MASK1);if(!spot) {board->row3 += (id <<OFFSET1); board->row4 += (id<<OFFSET1); board->row3&=~ ( id << OFFSET0);board->row4&=~ ( id << OFFSET0);}break;
					case 1: spot = (board->row3 & MASK2) | (board->row4 & MASK2);if(!spot) {board->row3 += (id <<OFFSET2); board->row4 += (id<<OFFSET2); board->row3&=~ ( id << OFFSET1);board->row4&=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row3 & MASK3) | (board->row4 & MASK3);if(!spot) {board->row3 += (id <<OFFSET3); board->row4 += (id<<OFFSET3); board->row3&=~ ( id << OFFSET2);board->row4&=~ ( id << OFFSET2);}break;

					}
				}break;
			default : printf(glb_errorMessage,ERROR_MOVE8);
			}
			if(!spot)
			{
				setLocation(blank1,row,col); setLocation(blank2,row+1, col);
			}
		}break;
	}

	return !spot;
}

int moveQuad(short int id, short int orientation, Board * board,char row, char col, Location * blank1, Location * blank2)
{
	short int spot = 0;
	// on tudie les cas limites
	switch(orientation)
	{
	case TOP : 
		{
			if (row == 0) return FALSE;
			switch(row)
			{
			case 1:
				{
					switch(col)
					{

					case 0: spot = (board->row0 & MASK0) | (board->row0 & MASK1); //la place est elle libre?
						if(!spot) 
						{

							board->row0 += (id <<OFFSET0) + (id << OFFSET1);
							board->row2&=~ ( id << OFFSET0); board->row2&=~ ( id << OFFSET1);
							setLocation(blank1, 2, 0);setLocation(blank2, 2, 1);
						} 
						break;
					case 1: spot = (board->row0 & MASK1) | (board->row0 & MASK2); 
						if(!spot)
						{

							board->row0 += (id <<OFFSET1) + (id << OFFSET2);
							board->row2&=~ ( id << OFFSET1); board->row2&=~ ( id << OFFSET2);
							setLocation(blank1, 2, 1);setLocation(blank2, 2, 2);
						}break;
					case 2: spot = (board->row0 & MASK2) | (board->row0 & MASK3);
						if(!spot) 
						{

							board->row0 += (id <<OFFSET2) + (id << OFFSET3);
							board->row2&=~ ( id << OFFSET2); board->row2&=~ ( id << OFFSET3);
							setLocation(blank1, 2, 2);setLocation(blank2, 2, 3);
						}break;
					}
				}break;
			case 2:
				{
					switch(col)
					{
					case 0: spot = (board->row1 & MASK0) | (board->row1 & MASK1);
						if(!spot)
						{

							board->row1 += (id <<OFFSET0) + (id << OFFSET1);
							board->row3 &=~ ( id << OFFSET0);board->row3&=~ ( id << OFFSET1);
							setLocation(blank1, 3, 0);setLocation(blank2, 3, 1);
						}break;
					case 1: 
						spot = (board->row1 & MASK1) | (board->row1 & MASK2);
						if(!spot)
						{

							board->row1 += (id <<OFFSET1) + (id << OFFSET2);
							board->row3&=~ ( id << OFFSET1); board->row3&=~ ( id << OFFSET2);
							setLocation(blank1, 3, 1);setLocation(blank2, 3, 2);
						}break;
					case 2: spot = (board->row1 & MASK2) | (board->row1 & MASK3);
						if(!spot)
						{

							board->row1 += (id <<OFFSET2) + (id << OFFSET3);
							board->row3&=~ ( id << OFFSET2); board->row3&=~ ( id << OFFSET3);
							setLocation(blank1, 3, 2);setLocation(blank2, 3, 3);
						}break;
					}
				}break;
			case 3:
				{
					switch(col)
					{
					case 0: spot = (board->row2 & MASK0) | (board->row2 & MASK1);
						if(!spot) 
						{

							board->row2 += (id <<OFFSET0); board->row2 += (id<<OFFSET1);
							board->row4&=~ ( id << OFFSET0);board->row4&=~ ( id << OFFSET1);
							setLocation(blank1, 4, 0);setLocation(blank2, 4, 1);
						}break;
					case 1: spot = (board->row2 & MASK1) | (board->row2 & MASK2);
						if(!spot)
						{

							board->row2 += (id <<OFFSET1); board->row2 += (id<<OFFSET2);
							board->row4&=~ ( id << OFFSET1);board->row4&=~ ( id << OFFSET2);
							setLocation(blank1, 4, 1);setLocation(blank2, 4, 2);
						}break;
					case 2: spot = (board->row2 & MASK2) | (board->row2 & MASK3);
						if(!spot) {

							board->row2 += (id <<OFFSET2); board->row2 += (id<<OFFSET3); 
							board->row4&=~ ( id << OFFSET2);board->row4&=~ ( id << OFFSET3);
							setLocation(blank1, 4, 3);setLocation(blank2, 4, 3);
						}break;
					}	
				}break;
			}
		}break;
	case BOTTOM :
		{
			if (row == 3) return FALSE;
			switch(row)
			{
			case 1:
				{
					switch(col)
					{
					case 0: spot = (board->row3 & MASK0) | (board->row3 & MASK1);
						if(!spot)
						{

							board->row3 += (id <<OFFSET0); board->row3 += (id<<OFFSET1);
							board->row1&=~ ( id << OFFSET0);board->row1&=~ ( id << OFFSET1);
							setLocation(blank1, 1, 0);setLocation(blank2, 1, 1);
						}break;
					case 1: spot = (board->row3 & MASK1) | (board->row3 & MASK2);
						if(!spot) 
						{

							board->row3 += (id <<OFFSET1); board->row3 += (id<<OFFSET2);
							board->row1&=~ ( id << OFFSET1);board->row1&=~ ( id << OFFSET2);
							setLocation(blank1, 1, 1);setLocation(blank2, 1, 2);
						}break;
					case 2: spot = (board->row3 & MASK2) | (board->row3 & MASK3);
						if(!spot) 
						{

							board->row3 += (id <<OFFSET2); board->row3 += (id<<OFFSET3);
							board->row1&=~ ( id << OFFSET2);board->row1&=~ ( id << OFFSET3);
							setLocation(blank1, 1, 2);setLocation(blank2, 1, 3);
						}break;
					}
				}break;
			case 2:
				{

					switch(col)
					{
					case 0: spot = (board->row4 & MASK0) | (board->row4 & MASK1);
						if(!spot) {

							board->row4 += (id <<OFFSET0); board->row4 += (id<<OFFSET1);
							board->row2&=~ ( id << OFFSET0);board->row2&=~ ( id << OFFSET1);
							setLocation(blank1, 2, 0);setLocation(blank2, 2, 1);
						}break;
					case 1: spot = (board->row4 & MASK1) | (board->row4 & MASK2);
						if(!spot) 
						{

							board->row4 += (id <<OFFSET1); board->row4 += (id<<OFFSET2); 
							board->row2&=~ ( id << OFFSET1);board->row2&=~ ( id << OFFSET2);
							setLocation(blank1, 2, 1);setLocation(blank2, 2, 2);
						}break;
					case 2: spot = (board->row4 & MASK2) | (board->row4 & MASK3);
						if(!spot)
						{

							board->row4 += (id <<OFFSET2); board->row4 += (id<<OFFSET3);
							board->row2&=~ ( id << OFFSET2);board->row2&=~ ( id << OFFSET3);
							setLocation(blank1, 2, 2);setLocation(blank2, 2, 3);
						}break;
					}	
				}break;
			case 0:
				{
					switch(col)
					{
					case 0: spot = (board->row2 & MASK0) | (board->row2 & MASK1);
						if(!spot) 
						{

							board->row2 += (id <<OFFSET0); board->row2 += (id<<OFFSET1); 
							board->row0&=~ ( id << OFFSET0);board->row0&=~ ( id << OFFSET1);
							setLocation(blank1, 0, 0);setLocation(blank2, 0, 1);
						}break;
					case 1: spot = (board->row2 & MASK1) | (board->row2 & MASK2);
						if(!spot) 
						{

							board->row2 += (id <<OFFSET1); board->row2 += (id<<OFFSET2);
							board->row0&=~ ( id << OFFSET1);board->row0&=~ ( id << OFFSET2);
							setLocation(blank1, 0, 1);setLocation(blank2, 0, 2);
						}break;
					case 2: spot = (board->row2 & MASK2) | (board->row2 & MASK3);
						if(!spot)
						{

							board->row2 += (id <<OFFSET2); board->row2 += (id<<OFFSET3);
							board->row0&=~ ( id << OFFSET2);board->row0&=~ ( id << OFFSET3);
							setLocation(blank1, 0, 2);setLocation(blank2, 0, 3);
						}break;

					}	
				}break;
			}

		}break;
	case RIGHT : 
		{
			if (col >= MAX_COL-2) return FALSE;
			switch(row)
			{
			case 1:
				{
					switch(col)
					{
					case 0: spot = (board->row1 & MASK2) | (board->row2 & MASK2);
						if(!spot)
						{

							board->row1 += (id <<OFFSET2);board->row2 += (id <<OFFSET2);
							board->row1&=~ ( id << OFFSET0);  board->row2&=~ ( id << OFFSET0);
							setLocation(blank1, 1, 0);setLocation(blank2, 2, 0);
						}break;
					case 1: spot = (board->row1 & MASK3) | (board->row2 & MASK3);
						if(!spot) 
						{

							board->row1 += (id <<OFFSET3);board->row2 += (id <<OFFSET3); 
							board->row1&=~ ( id << OFFSET1); board->row2&=~ ( id << OFFSET1);
							setLocation(blank1, 1, 1);setLocation(blank2, 2, 1);
						}break;
					}
				}break;
			case 0:
				{
					switch(col)
					{
					case 0: spot = (board->row0 & MASK2) | (board->row1 & MASK2);
						if(!spot) 
						{

							board->row0 += (id <<OFFSET2);board->row1 += (id <<OFFSET2); 
							board->row0&=~ ( id << OFFSET0);  board->row1&=~ ( id << OFFSET0);
							setLocation(blank1, 0, 0);setLocation(blank2, 1, 0);
						}break;
					case 1: spot = (board->row0 & MASK3) | (board->row1 & MASK3);
						if(!spot) 
						{

							board->row0 += (id <<OFFSET3);board->row1 += (id <<OFFSET3); 
							board->row0&=~ ( id << OFFSET1);  board->row1&=~ ( id << OFFSET1);
							setLocation(blank1, 0, 1);setLocation(blank2, 1, 1);
						}break;
					}	
				}break;
			case 2 :
				{
					switch(col)
					{
					case 0: spot = (board->row2 & MASK2) | (board->row3 & MASK2);
						if(!spot) 
						{

							board->row2 += (id <<OFFSET2);board->row3 += (id <<OFFSET2); 
							board->row2&=~ ( id << OFFSET0);  board->row3&=~ ( id << OFFSET0);
							setLocation(blank1, 2, 0);setLocation(blank2, 3, 0);
						}break;
					case 1: spot = (board->row2 & MASK3) | (board->row3 & MASK3);
						if(!spot) 
						{

							board->row2 += (id <<OFFSET3);board->row3 += (id <<OFFSET3); 
							board->row2&=~ ( id << OFFSET1);  board->row3&=~ ( id << OFFSET1);
							setLocation(blank1, 2, 1);setLocation(blank2, 3, 1);
						}break;
					}	
				}break;
			case 3 :
				{
					switch(col)
					{
					case 0: spot = (board->row3 & MASK2) | (board->row4 & MASK2);
						if(!spot) 
						{

							board->row3 += (id <<OFFSET2);board->row4 += (id <<OFFSET2); 
							board->row3&=~ ( id << OFFSET0);  board->row4&=~ ( id << OFFSET0);
							setLocation(blank1, 3, 0);setLocation(blank2, 4, 0);
						}break;
					case 1: spot = (board->row3 & MASK3) | (board->row4 & MASK3);
						if(!spot) 
						{

							board->row3 += (id <<OFFSET3);board->row4 += (id <<OFFSET3); 
							board->row3&=~ ( id << OFFSET1);  board->row4&=~ ( id << OFFSET1);
							setLocation(blank1, 3, 1);setLocation(blank2, 4, 1);
						}break;
					}	
				}break;
			}
		}break;
	case LEFT :
		{
			if (col == 0 || row ==4 ) return FALSE;
			switch(row)
			{
			case 1:
				{

					switch(col)
					{
					case 1: spot = (board->row1 & MASK0) | (board->row2 & MASK0);
						if(!spot) 
						{

							board->row1 += (id <<OFFSET0);board->row2 += (id <<OFFSET0);  
							board->row1&=~ ( id << OFFSET2);  board->row2&=~ ( id << OFFSET2);
							setLocation(blank1, 1, 2);setLocation(blank2, 2, 2);
						}break;
					case 2: spot = (board->row1 & MASK1) | (board->row2 & MASK1);
						if(!spot) 
						{

							board->row1 += (id <<OFFSET1);board->row2 += (id <<OFFSET1); 
							board->row1&=~ ( id << OFFSET3);  board->row2&=~ ( id << OFFSET3);
							setLocation(blank1, 1, 3);setLocation(blank2, 2, 3);
						}break;
					}
				}break;
			case 2:
				{

					switch(col)
					{
					case 1: spot = (board->row2 & MASK0) | (board->row3 & MASK0);
						if(!spot)
						{

							board->row2 += (id <<OFFSET0);board->row3 += (id <<OFFSET0); 
							board->row2&=~ ( id << OFFSET2);  board->row3&=~ ( id << OFFSET2);
							setLocation(blank1, 2, 2);setLocation(blank2, 3, 2);
						}break;
					case 2: spot = (board->row2 & MASK1) | (board->row3 & MASK1);
						if(!spot)
						{

							board->row2 += (id <<OFFSET1);board->row3 += (id <<OFFSET1); 
							board->row2&=~ ( id << OFFSET3);  board->row3&=~ ( id << OFFSET3);
							setLocation(blank1, 2, 3);setLocation(blank2, 3, 3);
						}break;
					}	

				}break;
			case 3:
				{
					switch(col)
					{
					case 1: spot = (board->row3 & MASK0) | (board->row4 & MASK0);
						if(!spot)
						{

							board->row3 += (id <<OFFSET0);board->row4 += (id <<OFFSET0); 
							board->row3&=~ ( id << OFFSET2);  board->row4&=~ ( id << OFFSET2);
							setLocation(blank1, 3, 2);setLocation(blank2, 4, 2);
						}break;
					case 2: spot = (board->row3 & MASK1) | (board->row4 & MASK1);
						if(!spot)
						{

							board->row3 += (id <<OFFSET1);board->row4 += (id <<OFFSET1); 
							board->row3&=~ ( id << OFFSET3);  board->row4&=~ ( id << OFFSET3);
							setLocation(blank1, 3, 3);setLocation(blank2, 4, 3);
						}break;
					}	

				}break;
			case 0:
				{
					switch(col)
					{
					case 1: spot = (board->row0 & MASK0) | (board->row1 & MASK0);
						if(!spot)
						{

							board->row0 += (id <<OFFSET0);board->row1 += (id <<OFFSET0); 
							board->row0&=~ ( id << OFFSET2);  board->row1&=~ ( id << OFFSET2);
							setLocation(blank1, 0, 2);setLocation(blank2, 1, 2);
						}break;
					case 2: spot = (board->row0 & MASK1) | (board->row1 & MASK1);
						if(!spot)
						{

							board->row0 += (id <<OFFSET1);board->row1 += (id <<OFFSET1); 
							board->row0&=~ ( id << OFFSET3);  board->row1&=~ ( id << OFFSET3);
							setLocation(blank1, 0, 3);setLocation(blank2, 1, 3);
						}break;
					}	

				}break;
			}
		}break;
	}
	return !spot;
}

int moveSimple(short int id, short int orientation, Board * board,char row, char col, Location * blank1, Location * blank2)
{
	short int spot = 0;
	char moveR =0; // la destination 
	char moveC =0;
	// on tudie les cas limites
	switch(orientation)
	{
	case TOP : 
		{
			if (row == 0) return FALSE;
			switch(row)
			{
			case 1:
				{
					switch(col)
					{
					case 0: spot = (board->row0 & MASK0);if (!spot){board->row0 += id << OFFSET0; board->row1 &=~ ( id << OFFSET0);} break;
					case 1: spot = (board->row0 & MASK1);if (!spot){board->row0 += id << OFFSET1; board->row1 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row0 & MASK2);if (!spot){board->row0 += id << OFFSET2; board->row1 &=~ ( id << OFFSET2);}break;
					case 3: spot = (board->row0 & MASK3);if (!spot){board->row0 += id << OFFSET3; board->row1 &=~ ( id << OFFSET3);}break;
					}
				}break;
			case 2:
				{

					switch(col)
					{
					case 0: spot = (board->row1 & MASK0);if (!spot){board->row1 += id << OFFSET0; board->row2 &=~ ( id << OFFSET0);} break;
					case 1: spot = (board->row1 & MASK1);if (!spot){board->row1 += id << OFFSET1; board->row2 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row1 & MASK2);if (!spot){board->row1 += id << OFFSET2; board->row2 &=~ ( id << OFFSET2);}break;
					case 3: spot = (board->row1 & MASK3);if (!spot){board->row1 += id << OFFSET3; board->row2 &=~ ( id << OFFSET3);}break;

					}	
				}break;
			case 3:
				{

					switch(col)
					{
					case 0: spot = (board->row2 & MASK0);if (!spot){board->row2 += id << OFFSET0; board->row3 &=~ ( id << OFFSET0);} break;
					case 1: spot = (board->row2 & MASK1);if (!spot){board->row2 += id << OFFSET1; board->row3 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row2 & MASK2);if (!spot){board->row2 += id << OFFSET2; board->row3 &=~ ( id << OFFSET2);}break;
					case 3: spot = (board->row2 & MASK3);if (!spot){board->row2 += id << OFFSET3; board->row3 &=~ ( id << OFFSET3);}break;

					}	
				}break;
			case 4:
				{

					switch(col)
					{
					case 0: spot = (board->row3 & MASK0);if (!spot){board->row3 += id << OFFSET0; board->row4 &=~ ( id << OFFSET0);} break;
					case 1: spot = (board->row3 & MASK1);if (!spot){board->row3 += id << OFFSET1; board->row4 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row3 & MASK2);if (!spot){board->row3 += id << OFFSET2; board->row4 &=~ ( id << OFFSET2);}break;
					case 3: spot = (board->row3 & MASK3);if (!spot){board->row3 += id << OFFSET3; board->row4 &=~ ( id << OFFSET3);}break;

					}	
				}break;
			}
			if(!spot)
			{
				moveR = row-1;
				moveC = col;
			}
		}break;
	case BOTTOM :
		{
			if (row == 4) return FALSE;
			switch(row)
			{
			case 1:
				{

					switch(col)
					{
					case 0: spot = (board->row2 & MASK0);if (!spot){board->row2 += id << OFFSET0; board->row1 &=~ ( id << OFFSET0);}
							break;
					case 1: spot = (board->row2 & MASK1);if (!spot){board->row2 += id << OFFSET1; board->row1 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row2 & MASK2);if (!spot){board->row2 += id << OFFSET2; board->row1 &=~ ( id << OFFSET2);}break;
					case 3: spot = (board->row2 & MASK3);if (!spot){board->row2 += id << OFFSET3; board->row1 &=~ ( id << OFFSET3);}break;
					}
				}break;
			case 2:
				{

					switch(col)
					{
					case 0: spot = (board->row3 & MASK0);if (!spot){board->row3 += id << OFFSET0; board->row2 &=~ ( id << OFFSET0);} break;
					case 1: spot = (board->row3 & MASK1);if (!spot){board->row3 += id << OFFSET1; board->row2 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row3 & MASK2);if (!spot){board->row3 += id << OFFSET2; board->row2 &=~ ( id << OFFSET2);}break;
					case 3: spot = (board->row3 & MASK3);if (!spot){board->row3 += id << OFFSET3; board->row2 &=~ ( id << OFFSET3);}break;

					}	
				}break;
			case 0:
				{

					switch(col)
					{
					case 0: spot = (board->row1 & MASK0);if (!spot){board->row1 += id << OFFSET0; board->row0 &=~ ( id << OFFSET0);} break;
					case 1: spot = (board->row1 & MASK1);if (!spot){board->row1 += id << OFFSET1; board->row0 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row1 & MASK2);if (!spot){board->row1 += id << OFFSET2; board->row0 &=~ ( id << OFFSET2);}break;
					case 3: spot = (board->row1 & MASK3);if (!spot){board->row1 += id << OFFSET3; board->row0 &=~ ( id << OFFSET3);}break;

					}	
				}break;
			case 3:
				{

					switch(col)
					{
					case 0: spot = (board->row4 & MASK0);if (!spot){board->row4 += id << OFFSET0; board->row3 &=~ ( id << OFFSET0);} break;
					case 1: spot = (board->row4 & MASK1);
						if (!spot)
						{

							board->row4 += id << OFFSET1;
							board->row3 &= ~(id << OFFSET1);}
						;break;
					case 2: spot = (board->row4 & MASK2);if (!spot){board->row4 += id << OFFSET2; board->row3 &=~ ( id << OFFSET2);}break;
					case 3: spot = (board->row4 & MASK3);if (!spot){board->row4 += id << OFFSET3; board->row3 &=~ ( id << OFFSET3);}break;

					}	

				}break;
			}
			if(!spot)
			{
				moveR = row+1;
				moveC = col;
			}
		}break;
	case RIGHT : 
		{
			if (col == MAX_COL-1) return FALSE;
			switch(row)
			{
			case 1:
				{

					switch(col)
					{
					case 0: spot = (board->row1 & MASK1);if (!spot){board->row1 += id << OFFSET1; board->row1 &=~ ( id << OFFSET0);}break;
					case 1: spot = (board->row1 & MASK2);if (!spot){board->row1 += id << OFFSET2; board->row1 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row1 & MASK3);if (!spot){board->row1 += id << OFFSET3; board->row1 &=~ ( id << OFFSET2);}break;
					}

				}break;
			case 2:
				{

					switch(col)
					{
					case 0: spot = (board->row2 & MASK1);if (!spot){board->row2 += id << OFFSET1; board->row2 &=~ ( id << OFFSET0);}break;
					case 1: spot = (board->row2 & MASK2);if (!spot){board->row2 += id << OFFSET2; board->row2 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row2 & MASK3);if (!spot){board->row2 += id << OFFSET3; board->row2 &=~ ( id << OFFSET2);}break;
					}	

				}break;
			case 0:
				{

					switch(col)
					{
					case 0: spot = (board->row0 & MASK1);if (!spot){board->row0 += id << OFFSET1; board->row0 &=~ ( id << OFFSET0);}break;
					case 1: spot = (board->row0 & MASK2);if (!spot){board->row0 += id << OFFSET2; board->row0 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row0 & MASK3);if (!spot){board->row0 += id << OFFSET3; board->row0 &=~ ( id << OFFSET2);}break;
					}	

				}break;
			case 3:
				{

					switch(col)
					{
					case 0: spot = (board->row3 & MASK1);if (!spot){board->row3 += id << OFFSET1; board->row3 &=~ ( id << OFFSET0);}break;
					case 1: spot = (board->row3 & MASK2);if (!spot){board->row3 += id << OFFSET2; board->row3 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row3 & MASK3);if (!spot){board->row3 += id << OFFSET3; board->row3 &=~ ( id << OFFSET2);}break;
					}	

				}break;
			case 4:
				{

					switch(col)
					{
					case 0: spot = (board->row4 & MASK1);if (!spot){board->row4 += id << OFFSET1; board->row4 &=~ ( id << OFFSET0);}break;
					case 1: spot = (board->row4 & MASK2);if (!spot){board->row4 += id << OFFSET2; board->row4 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row4 & MASK3);if (!spot){board->row4 += id << OFFSET3; board->row4 &=~ ( id << OFFSET2);}break;
					}	

				}break;
			}
			if(!spot)
			{
				moveR =  row;
				moveC = col+1;
			}
		}break;
	case LEFT :
		{
			if (col == 0) return FALSE;
			switch(row)
			{
			case 1:
				{

					switch(col)
					{
					case 3: spot = (board->row1 & MASK2);if (!spot){board->row1 += id << OFFSET2; board->row1 &=~ ( id << OFFSET3);}break;
					case 1: spot = (board->row1 & MASK0);if (!spot){board->row1 += id << OFFSET0; board->row1 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row1 & MASK1);if (!spot){board->row1 += id << OFFSET1; board->row1 &=~ ( id << OFFSET2);}break;
					}

				}break;
			case 2:
				{

					switch(col)
					{
					case 3: spot = (board->row2 & MASK2);if (!spot){board->row2 += id << OFFSET2; board->row2 &=~ ( id << OFFSET3);}break;
					case 1: spot = (board->row2 & MASK0);if (!spot){board->row2 += id << OFFSET0; board->row2 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row2 & MASK1);if (!spot){board->row2 += id << OFFSET1; board->row2 &=~ ( id << OFFSET2);}break;
					}	

				}break;
			case 3:
				{

					switch(col)
					{
					case 3: spot = (board->row3 & MASK2);if (!spot){board->row3 += id << OFFSET2; board->row3 &=~ ( id << OFFSET3);}break;
					case 1: spot = (board->row3 & MASK0);if (!spot){board->row3 += id << OFFSET0; board->row3 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row3 & MASK1);if (!spot){board->row3 += id << OFFSET1; board->row3 &=~ ( id << OFFSET2);}break;
					}	

				}break;
			case 0:
				{

					switch(col)
					{
					case 3: spot = (board->row0 & MASK2);if (!spot){board->row0 += id << OFFSET2; board->row0 &=~ ( id << OFFSET3);}break;
					case 1: spot = (board->row0 & MASK0);if (!spot){board->row0 += id << OFFSET0; board->row0 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row0 & MASK1);if (!spot){board->row0 += id << OFFSET1; board->row0 &=~ ( id << OFFSET2);}break;
					}	

				}break;

			case 4:
				{

					switch(col)
					{
					case 3: spot = (board->row4 & MASK2);if (!spot){board->row4 += id << OFFSET2; board->row4 &=~ ( id << OFFSET3);}break;
					case 1: spot = (board->row4 & MASK0);if (!spot){board->row4 += id << OFFSET0; board->row4 &=~ ( id << OFFSET1);}break;
					case 2: spot = (board->row4 & MASK1);if (!spot){board->row4 += id << OFFSET1; board->row4 &=~ ( id << OFFSET2);}break;
					}	

				}break;
			}
			if(!spot)
			{
				moveR =  row;
				moveC =  col-1;
			}
		}break;
	}

	if(!spot)
	{
		char isBlank1 =  blank1->column == moveC && blank1->row == moveR;

		if(isBlank1)
			setLocation(blank1, row, col);
		else
			setLocation(blank2, row, col);
	}
	return !spot;
}

int moveToken(short int id, short int orientation, Board * board,char row, char column, Location * blank1, Location * blank2)
{
	int res = FALSE;

	switch (getTokenTypeFromId(id))
	{
	case DOUBLE_VERTICAL:			res = moveDoubleVertical(id, orientation, board, row, column, blank1, blank2);	break;
	case DOUBLE_HORIZONTAL:			res = moveDoubleHorizontal(id, orientation, board, row, column, blank1, blank2);	break;
	case QUAD:						res = moveQuad(id, orientation, board, row, column, blank1, blank2);	break;
	case SIMPLE:					res = moveSimple(id, orientation, board, row, column, blank1, blank2);	break;
	}

	return res;
}
