///////////////////////////////////////
//  copyright Alexandre Chouvellon 2009
//  Source libre de droit
///////////////////////////////////////
#include <stdio.h>
#include <stdlib.h>
#include "donkey.h"
#include "structure.h"
#include "language.fwd.h"
#include "errorId.h"
Token glb_tokens[12]; // la liste de pieces

short int  getIdfromBoard(Board * board, char x , char y)
{
   short int row =0;
   short int mask =0;
   char offset=0;

   if(x <0 && y > 3)
      return -1;
   switch(x)
   {
   case 0:row = board->row0;break;
   case 1:row = board->row1;break;
   case 2:row = board->row2;break;
   case 3:row = board->row3;break;
   case 4:row = board->row4;break;
   }
   switch(y)
   {
   case 0:mask = MASK0;offset = OFFSET0;break;
   case 1:mask = MASK1;offset =OFFSET1;break;
   case 2:mask = MASK2;offset=OFFSET2;break;
   case 3:mask = MASK3;break;
   }

   return ((row & mask) >> offset) & 0x000F;
}

Action inverseAction( Action a)
{
   Action newAction = -1;
   short int orientation = (a & MASK2) >> 4; 
   short int id = (a & MASK3); 
   switch(orientation)
   {
   case TOP: newAction = (id | (BOTTOM <<4));break;
   case BOTTOM:newAction = (id | (TOP <<4));break;
   case RIGHT:newAction = (id | (LEFT <<4));break;
   case LEFT:newAction = (id | (RIGHT <<4));break;
   case 15:break;
   default : printf(glb_errorMessage, ERROR_INVERSE);
   }
   return newAction;
}


int  getTokenTypeFromId(short int id)
{
   return glb_tokens[id].type;
}

int  getTypeFromId(short int id)
{
   switch(id)
   {
   case 0: return BLANK1;
   case 1: return BLANK1;
   case 2: return SIMPLE;
   case 3: return SIMPLE;
   case 4: return SIMPLE;
   case 5: return SIMPLE;
   case 6:
   case 7: 
   case 8: 
   case 9: 
   case 10: return DOUBLE_HORIZONTAL;
   case 11: return QUAD;
   }

   return 0xFFFF;
}

void setLocation(Location * location, char r, char c)
{
   location->column = c;
   location->row = r;
}

char  getLetterFromId( short id)
{
   return ((char)id)+ 'A';
}

void setOrRemoveId(Board * board,short int id, char r , char c, char set)
{
   short int  *row = NULL;
   short int offset;
   short int mask;
   switch(r)
   {
   case 0: row = &board->row0;break;
   case 1: row = &board->row1;break;
   case 2: row = &board->row2;break;
   case 3: row = &board->row3;break;
   case 4: row = &board->row4;break;
   default :  printf(glb_errorMessage,ERROR_ROW);exit(0);
   }

   switch(c)
   {
   case 0: mask = MASK0;offset = OFFSET0;break;
   case 1: mask = MASK1;offset = OFFSET1;break;
   case 2: mask = MASK2;offset = OFFSET2;break;
   case 3: mask = MASK3;offset = OFFSET3;break;
   default :  printf(glb_errorMessage,ERROR_COLUMN);exit(0);
   }
   if(!set)
   {
      *row &= ~(id << offset);

   }
   else{
      *row |= (id << offset);

   }
}

void copyLocation(Location * source, Location * dest)
{
   if (source && dest)
   {
      dest->column =source->column ;
      dest->row =source->row ;
   }
}

void copyBoard(Board * source, Board * dest)
{
   if(source && dest)
   {
      dest->row0 = source->row0;
      dest->row1 = source->row1;
      dest->row2 = source->row2;
      dest->row3 = source->row3;
      dest->row4 = source->row4;
   }
}

void setType(int id, int type)
{
   glb_tokens[id].type = type;
}

void setRow(Board * board, short row, int rowNb)
{
   switch(rowNb)
   {
   case 0:board->row0 = row;break;
   case 1:board->row1 = row;break;
   case 2:board->row2 = row;break;
   case 3:board->row3 = row;break;
   case 4:board->row4 = row;break;
   default:    printf(glb_errorMessage, ERROR_ROW_NUMBER);
   }
}

short  getRow(Board * board,  int rowNb)
{
   switch(rowNb)
   {
   case 0: return board->row0;
   case 1: return board->row1;
   case 2: return board->row2;
   case 3: return board->row3;
   case 4: return board->row4;
   }

   printf(glb_errorMessage, ERROR_ROW_NUMBER);

   return -1;
}

Location *getLocationToken(int id)
{
   return &(glb_tokens[id].location);
}
